diff -Naur pcre-ocaml-release-5.15.1/OCamlMakefile pcre-ocaml-release-5.15.1.new/OCamlMakefile
--- pcre-ocaml-release-5.15.1/OCamlMakefile	2008-11-29 05:30:56.000000000 +0000
+++ pcre-ocaml-release-5.15.1.new/OCamlMakefile	2009-02-20 09:55:37.659000000 +0000
@@ -352,11 +352,20 @@
 export OCAMLMAKEFILE
 
 ifndef OCAMLLIBPATH
+ifdef WIN32
+  OCAMLLIBPATH := \
+    $(shell cygpath -u `$(OCAMLC) 2>/dev/null -where` || echo /cygdrive/c/ocamlmgw)
+else
   OCAMLLIBPATH := \
     $(shell $(OCAMLC) 2>/dev/null -where || echo /usr/local/lib/ocaml)
 endif
+endif
 export OCAMLLIBPATH
 
+ifeq ($(shell ocamlc -config | fgrep "version: 3.11" > /dev/null && echo 1), 1)
+	OCAML311 := 1
+endif
+
 ifndef OCAML_LIB_INSTALL
   OCAML_LIB_INSTALL := $(OCAMLLIBPATH)/contrib
 endif
@@ -481,7 +490,12 @@
 endif
 
 ifdef WIN32
+# @@DRA Not sure that this shouldn't always be dll$(CLIB_BASE).dll?
+ifdef OCAML311
+DLLSONAME := dll$(CLIB_BASE).dll
+else
 DLLSONAME := $(CLIB_BASE).dll
+endif
 else
 DLLSONAME := dll$(CLIB_BASE).so
 endif
@@ -897,12 +911,19 @@
 
 ifndef STATIC
 ifdef MINGW
+ifdef OCAML311
+$(DLLSONAME):		$(OBJ_LINK)
+			$(OCAMLMKLIB) $(INCFLAGS) $(CLIBFLAGS) \
+				-o $(CLIB_BASE) $(OBJ_LINK) $(CLIBS:%=-l%) $(CFRAMEWORKS:%=-framework %) \
+				$(OCAMLMKLIB_FLAGS)
+else
 $(DLLSONAME):		$(OBJ_LINK)
 			$(CC) $(CFLAGS) $(CFLAGS_WIN32) $(OBJ_LINK) -shared -o $@ \
 			-Wl,--whole-archive $(wildcard $(foreach dir,$(LIBDIRS),$(CLIBS:%=$(dir)/lib%.a))) \
 			 $(OCAMLLIBPATH)/ocamlrun.a \
 			-Wl,--export-all-symbols \
 			-Wl,--no-whole-archive
+endif
 else
 ifdef MSVC
 $(DLLSONAME):		$(OBJ_LINK)
